'#Language "WWB-COM"
''MACRO TITLE: wCreate DataVault Object
' MACRO VERSION: 1.1
'This macro calls other macros
'
' Release notes
' 1.1: Checks the number of selected objects in the current active submodel
' 1.0 Initial version
'---------------------------------------------------------------------------

Option Explicit

Const TITLE$ = "wCreate DataVault Object"

Dim MyDiagram As Diagram
Dim MyModel As Model
Dim MySubModel As SubModel

Dim iSelectedObjectsCount%

Sub Main
	
	Debug.Clear

	Begin Dialog UserDialog 300,133,TITLE,.DlgFunction ' %GRID:10,7,1,1
		OptionGroup .DVMacro
			OptionButton 20,35,140,14,"a Hub",.obHub			 ' 0
			OptionButton 20,56,140,14,"a Satellite",.obSatellite ' 1
			OptionButton 20,77,140,14,"a Link",.obLink			 ' 2
		Text 10,7,270,14,"Select the type of object you want to create:",.Text1
		OKButton 10,105,90,21
		CancelButton 200,105,90,21
	End Dialog

	Dim dlg As UserDialog
	Dim sMacro$

	iSelectedObjectsCount = -1

	'Get the current diagram.
	Set MyDiagram = DiagramManager.ActiveDiagram

	If Not MyDiagram Is Nothing Then
		'Get the current model.
		Set MyModel = MyDiagram.ActiveModel
	
		If Not MyModel Is Nothing Then
			'Get the current submodel.
			Set MySubModel = MyModel.ActiveSubModel
		
			If Not MySubModel Is Nothing Then
				iSelectedObjectsCount = MySubModel.SelectedObjects.Count
			End If

		End If

	End If

	If Dialog(dlg) = -1 Then
		Select Case dlg.DVMacro
		Case 0
			sMacro = "Hub"
		Case 1
			sMacro = "Satellite"
		Case 2
			sMacro = "Link"
		Case Else
			sMacro = ""
		End Select
		If Not IsMacroAvailable(sMacro) Then
			Debug.Print "The macro ""w" & sMacro & ".bas"" is not available in the folder """ & MacroDir & """"
			sMacro = ""
		End If
		Debug.Print "Option: " & Mid(sMacro, 2)

		If sMacro = "" Then
			MsgBox "You need to select an available option!", vbExclamation, TITLE
		Else
			MacroRun MacroDir & "\w" & sMacro & ".bas"
		End If
	End If

End Sub

Rem See DialogFunc help topic for more information.
Private Function DlgFunction(DlgItem As String, Action As Integer, SuppValue As PortInt) As Boolean
	Select Case Action
	Case 1 ' Dialog box initialization
		DlgEnable("obHub", IsMacroAvailable("Hub") And (iSelectedObjectsCount = 1))
		DlgEnable("obSatellite", IsMacroAvailable("Satellite") And (iSelectedObjectsCount = 1))
		DlgEnable("obLink", IsMacroAvailable("Link") And (iSelectedObjectsCount >= 2))

		If Not DlgEnable("obHub") Then
			If DlgEnable("obSatellite") Then
				DlgValue("DVMacro", 1)
			Else
				DlgValue("DVMacro", 2)
			End If
		End If
		DlgEnable("OK", DlgEnable("obHub") Or DlgEnable("obSatellite") Or DlgEnable("obLink"))
	Case 2
		If DlgItem = "OK" Then
			Dim sMacro$
			Select Case DlgValue "DVMacro"
			Case 0
				sMacro = "Hub"
			Case 1
				sMacro = "Satellite"
			Case 2
				sMacro = "Link"
			Case Else
				' No option selected: it should not be possible
				sMacro = ""
				DlgFunction = True
				Exit Function
			End Select
			If Not DlgEnable("ob" & sMacro) Then
				MsgBox "The macro ""w" & sMacro & ".bas"" is not available in the folder """ & MacroDir & """", vbExclamation, TITLE
				DlgFunction = True
			End If
		End If
	End Select
End Function

Private Function IsMacroAvailable(sName$) As Boolean
	IsMacroAvailable = (Dir$(MacroDir & "\w" & sName & ".bas") <> "")
End Function
